import 'package:flutter/material.dart';
import 'package:hub/backend/api_requests/api_manager.dart';
import 'package:hub/components/templates_components/details_component/details_component_widget.dart';
import 'package:hub/flutter_flow/flutter_flow_model.dart';
import 'package:hub/flutter_flow/flutter_flow_theme.dart';
import 'package:hub/flutter_flow/internationalization.dart';
import 'package:hub/pages/vehicles_on_the_property/vehicles_on_the_property.dart';
import 'package:hub/shared/utils/storage_util.dart';

class VisitsModel extends FlutterFlowModel<VehicleOnTheProperty> {
  static VisitsModel? _instance = VisitsModel._internal();
  VisitsModel._internal();
  factory VisitsModel() => _instance ?? VisitsModel._internal();
  static void resetInstance() => _instance = null;

  dynamic item;

  @override
  void initState(BuildContext context) {
    resetInstance();

    initAsync();
  }

  @override
  void dispose() {}

  Future<void> initAsync() async {}

  Widget buildVisitDetails({
    required dynamic item,
    required BuildContext context,
    required VisitsModel model,
  }) {
    return DetailsComponentWidget(
      buttons: [],
      labelsHashMap: Map<String, String>.from({
        if (item['MOT_DESCRICAO'] != null && item['MOT_DESCRICAO'] != '')
          '${FFLocalizations.of(context).getVariableText(
            ptText: "Motivo",
            enText: "Reason",
          )}:': item['MOT_DESCRICAO'].toString().toUpperCase(),
        if (item['VTA_DTINICIO'] != null && item['VTA_DTINICIO'] != '')
          '${FFLocalizations.of(context).getVariableText(
            ptText: "Data de Início",
            enText: "Start Date",
          )}:': item['VTA_DTINICIO'].toString().toUpperCase(),
        if (item['VTA_VALIDADE'] != null && item['VTA_VALIDADE'] != '')
          '${FFLocalizations.of(context).getVariableText(
            ptText: "Validade",
            enText: "Validity",
          )}:': item['VTA_VALIDADE'].toString().toUpperCase(),
        if (item['VTA_FIXA'] != null && item['VTA_FIXA'] != '')
          '${FFLocalizations.of(context).getVariableText(
            ptText: "Entrada Única",
            enText: "Single Entry",
          )}:': item['VTA_FIXA'] == true
              ? FFLocalizations.of(context).getVariableText(
                  ptText: "Sim",
                  enText: "Yes",
                )
              : FFLocalizations.of(context).getVariableText(
                  ptText: "Não",
                  enText: "No",
                ),
      }),
      imagePath:
          'https://freaccess.com.br/freaccess/getImage.php?devUUID=${StorageUtil().devUUID}&cliID=${StorageUtil().cliUUID}&atividade=getFoto&Documento=${item['VDO_DOCUMENTO']}&tipo=E',
      statusHashMap: [
        if (item['VTA_NOME'] != null)
          Map<String, Color>.from(
              {item['VTA_NOME'].toString().toUpperCase(): FlutterFlowTheme.of(context).warning}),
      ],
    );
  }
}
